<template>
  <div class="flex-grow-1 flex-row" v-bind:class="displayClass">
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"></clip-loader>
          </span>
          <div class="mb-4"></div>
        </div>
      </div>
    </template>
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-4">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>
    <template v-else>
      <slot></slot>
    </template>
  </div>
</template>

<script>
import ClipLoader from 'vue-spinner/src/ClipLoader'
import { findParentComponentByName } from '@/core/util'

export default {
  name: 'infocontainer',
  props: {
    name: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      loading: true,
      error: null,
    }
  },
  computed: {
    queryPanel: {
      get() {
        return findParentComponentByName(this.$parent, 'querypanel')
      }
    },

    displayClass: {
      get() {
        return this.queryPanel.currentPanel === this.name ? 'd-flex' : 'd-none'
      },
    },
  },
  methods: {
    setLoading(value) {
      this.loading = value
      return this
    },

    setError(value) {
      this.error = value
      return this
    },

    resetError() {
      this.error = null
      return this
    }
  },
  components: {
    ClipLoader,
  },
}
</script>
